%{!?upstream_version: %global upstream_version %{version}%{?milestone}}
%global drv_vendor VMware
%global srcname vmware-nsx
%global docpath doc/build/html
%global service neutron

Name:           python-networking-%{srcname}
Version: 9.2.0
Release: 5%{?dist}
Provides: python2-networking-vmware-nsx = %{version}-%{release}
Summary:        %{drv_vendor} OpenStack Neutron driver

License:        ASL 2.0
URL:            https://pypi.python.org/pypi/%{srcname}
Source0:        https://tarballs.openstack.org/%{srcname}/%{srcname}-%{upstream_version}.tar.gz
#
# patches_ignore=DROP-IN-RPM
# patches_base=9.2.0
#
Patch0001: 0001-NSX-V-serialize-rule-creation.patch
Patch0002: 0002-AdminUtil-NSX-v-Fix-constants-import.patch
Patch0003: 0003-NSX-V-ensure-that-DVS-name-is-unique.patch
Patch0004: 0004-Name-and-ID-validation-may-be-paginated.patch
Patch0005: 0005-Fix-to-use-correct-config-options-for-image_ssh_user.patch
Patch0006: 0006-NSX-V-skip-failing-unit-test.patch
Patch0007: 0007-Prevent-non-admin-user-specifying-port-s-provider-se.patch
Patch0008: 0008-Fix-unit-tests.patch
Patch0009: 0009-NSXv-Fix-tempest-test-failures-due-to-KeyError-prima.patch
Patch0010: 0010-Backport-neutron-integration-fixes.patch
Patch0011: 0011-NSX-V3-fix-exclude-port-issues.patch
Patch0012: 0012-NSX-V3-Fix-exclude-port-issue-during-delete-port.patch
Patch0013: 0013-NSX-V-Fail-dist-router-set-gw-if-edge-not-found.patch
Patch0014: 0014-Update-api-replay-for-nsx-v-nsx-v3-migration.patch
Patch0015: 0015-Address-network-filtering-issue.patch
Patch0016: 0016-Revert-Fixing-setup.cfg-whitespace-issues.patch
Patch0017: 0017-NSX-V3-treat-missing-exclude-list-entry-on-delete.patch
Patch0018: 0018-NSX-V-ensure-that-FLAT-provider-network-is-deleted.patch
Patch0019: 0019-Rename-api-replay-to-nsx-migration.patch
Patch0020: 0020-Fix-nsx-migration-script.patch
Patch0021: 0021-NSX-Migration-support-keystone-v3-other-fixes.patch
Patch0022: 0022-NSX-migration-remove-physical-network-for-flat-netwo.patch
Patch0023: 0023-NSX-V-LOG.exception-only-when-there-is-an-exception.patch
Patch0024: 0024-NSX-V3-ensure-that-MAC-learning-does-not-invoke-swit.patch
Patch0025: 0025-NSX-V3-treat-concurrent-stale-operations-for-exclude.patch
Patch0026: 0026-NSXV3-harden-subnet-creation-for-external-networks.patch
Patch0027: 0027-NSX-V3-retry-on-FW-Stale-resources.patch
Patch0028: 0028-NSX-V3-devstack-cleanup-exclude-list-ports-on-devsta.patch

# TODO: some of those dependencies are not available in repos, so left them version-less
BuildArch:      noarch
BuildRequires:  python2-devel
#BuildRequires:  python-mock >= 1.1
BuildRequires:  python-mock
BuildRequires:  python-oslo-sphinx
BuildRequires:  python-pbr
BuildRequires:  python-setuptools
BuildRequires:  python-sphinx
# Required for config file generation
BuildRequires:  python-debtcollector
BuildRequires:  python-oslo-config >= 2:1.11.0
BuildRequires:	python-oslo-i18n >= 1.5.0
BuildRequires:	python-oslo-vmware >= 0.13.1
BuildRequires:	python-neutron

#Requires:	python-eventlet >= 0.17.4
Requires:	python-eventlet
Requires:	python-httplib2 >= 0.7.5
Requires:	python-netaddr >= 0.7.12
Requires:	python-neutron
Requires:	python-oslo-concurrency >= 2.1.0
Requires:	python-oslo-config >= 2:1.11.0
Requires:	python-oslo-db >= 1.12.0
Requires:	python-oslo-i18n >= 1.5.0
Requires:	python-oslo-log >= 1.6.0
Requires:	python-oslo-serialization >= 1.4.0
Requires:	python-oslo-service >= 0.1.0
Requires:	python-oslo-utils >= 1.9.0
Requires:	python-oslo-vmware >= 0.13.1
Requires:	python-pbr >= 1.3
Requires:	python-retrying >= 1.2.3
Requires:	python-six >= 1.9.0
Requires:	python-sqlalchemy >= 0.9.7
Requires:	python-stevedore >= 1.5.0
#Requires:	python-tooz >= 0.16.0
Requires:	python-tooz


%description
This package contains %{drv_vendor} networking driver for OpenStack Neutron.


%package doc
Summary:        %{summary} documentation
Requires:       %{name} = %{version}-%{release}


%description doc
This package contains documentation for %{drv_vendor} networking driver for
OpenStack Neutron.


%prep
%setup -q -n %{srcname}-%{upstream_version}

%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1
%patch0018 -p1
%patch0019 -p1
%patch0020 -p1
%patch0021 -p1
%patch0022 -p1
%patch0023 -p1
%patch0024 -p1
%patch0025 -p1
%patch0026 -p1
%patch0027 -p1
%patch0028 -p1

rm requirements.txt test-requirements.txt


%build
%{__python2} setup.py build
%{__python2} setup.py build_sphinx
rm %{docpath}/.buildinfo


%install
export PBR_VERSION=%{version}
export SKIP_PIP_INSTALL=1
%{__python2} setup.py install --skip-build --root %{buildroot}

# Build config file
PYTHONPATH=. tools/generate_config_file_samples.sh

# Move config files to proper location
install -d -m 755 %{buildroot}%{_sysconfdir}/%{service}/plugins/vmware
mv etc/nsx.ini.sample %{buildroot}%{_sysconfdir}/%{service}/plugins/vmware/nsx.ini

%files
%license LICENSE
%{_bindir}/nsx-migration
%{_bindir}/neutron-api-replay
%{_bindir}/neutron-check-nsx-config
%{_bindir}/nsxadmin
%{python2_sitelib}/vmware_nsx
%{python2_sitelib}/vmware_nsx-%{version}-py%{python2_version}.egg-info
%dir %{_sysconfdir}/%{service}/plugins/vmware
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/plugins/vmware/*.ini


%files doc
%license LICENSE
%doc %{docpath}


%changelog
* Fri Oct 20 2017 Jason Joyce <jjoyce@redhat.com> 9.2.0-5
- NSX|V3: devstack cleanup exclude list ports on devstack
- NSX|V3: retry on FW Stale resources
- NSXV3: harden subnet creation for external networks
- NSX|V3: ensure that MAC learning does not invoke switch profiles

* Fri Sep 01 2017 Steve Linabery <slinaber@redhat.com> 9.2.0-4
- NSX|V3: treat concurrent stale operations for exclude list
- NSX|V3: ensure that MAC learning does not invoke switch profiles

* Thu Aug 03 2017 Jason Joyce <jjoyce@redhat.com> 9.2.0-3
- NSX|V: LOG.exception only when there is an exception
- NSX-migration: remove physical-network for flat networks
- NSX Migration: support keystone v3 & other fixes
- Fix nsx-migration script
- Rename api-replay to nsx-migration
- NSX|V: ensure that FLAT provider network is deleted
- NSX|V3: treat missing exclude list entry on delete
- Revert "Fixing setup.cfg whitespace issues"

* Mon May 22 2017 Jason Joyce <jjoyce@redhat.com> 9.2.0-2
- Address network filtering issue
- Update api-replay for nsx-v->nsx-v3 migration
- NSX|V Fail dist router set gw if edge not found
- NSX|V3: Fix exclude port issue during delete port
- NSX|V3: fix exclude port issues
- Backport neutron integration fixes
- NSXv: Fix tempest test failures due to KeyError 'primaryAddress'
- Fix unit tests
- Prevent non-admin user specifying port's provider-security-groups
- NSX|V: skip failing unit test
- Fix to use correct config options for image_ssh_user
- Name and ID validation may be paginated
- NSX|V: ensure that DVS name is unique
- AdminUtil NSX|v Fix constants import
- NSX|V: serialize rule creation

* Wed Mar 15 2017 Jon Schlueter <jschluet@redhat.com> 9.2.0-1
- Update to 9.2.0 (rhbz#1432640)

* Mon Nov 28 2016 Jon Schlueter <jschluet@redhat.com> 9.1.0-2
- Use stable for networking-l2gw
- NSX|V3: ensure that the NSX port name is updated correctly
- NSX|V3: only configure mac-learning if necessary
- NSXv3: Change default metadata route to 169.254.169.254/31
- Stable - peg Newton versions
- NSXv3: Fix string format in a logging message
- NSXv3: Fix a router port name update issue

* Tue Nov 22 2016 Jon Schlueter <jschluet@redhat.com> 9.1.0-1
- Update to 9.1.0
